//---------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma resource "*.dfm"

// PW8051 Assembler Version: 1.1.2      for dynamic path deside
// Job Finished Time: Nov. , 27th, 2003  -- 00:05 @ home
// Copyright: Pei-Wei Tsai      E-mail: pwtsai@bit.kuas.edu.tw

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
  FILE* dfpa;
  FILE* dfpl;
  FILE* dfpo;
  FILE* dfpx;
//---------------------------------------------------------------------------
  int ch_count, ins=0, pc=0, sp=0, s_d=0, m=0, web=1;
  char spx[10][8];
  char replace[10];
//---------------------------------------------------------------------------
void go_8(char spac[200])
{
  int len, add;

  len=strlen(spac);
  add=8-(len%8);

  for(int e=0;e<add;e++)
        strcat(spac," ");
}
//---------------------------------------------------------------------------
void closefile()
{
  fclose(dfpa);
  fclose(dfpo);
  fclose(dfpl);
  fclose(dfpx);
}
//---------------------------------------------------------------------------
void linecount(char space[200], int n)
{
  int n2;

  if(n<10)                      //n<10:space=6bits
  {
        space[0]=n+48;
        for(int c=1;c<=8;c++)
                space[c]=' ';
  }
  if((n<100)||(10<=n))                //9<n<100:space=5bits
  {
        n2=n/10;
        space[0]=n2+48;
        space[1]=(n%10)+48;
        for(int c=2;c<=8;c++)
                space[c]=' ';
  }
  if(100<=n)
  {
        n2=n/100;
        space[0]=n2+48;
        n2=(n%100)+48;
        space[1]=(n2/10)+48;
        space[2]=(n2%10)+48;
        for(int c=3;c<=8;c++)
                space[c]=' ';
  }
}
//---------------------------------------------------------------------------
void modins(char instruction[200])
{
  char temp[200],*p;

  if((p=strstr(instruction,"\x0a"))!=NULL)
        *p=0x0;
  if((p=strstr(instruction,"\x0d"))!=NULL)
        *p=0x0;
  if((p=strstr(instruction,"0x3b"))!=NULL)
        *p=0x0;

  while((p=strstr(instruction,"\x09"))!=NULL)   //0x09Tab
  {
        int n;
        if(*(p+1)==0x0)
                break;
        strcpy(temp,p+1);
        *p=0x0;
        n=(p-instruction);
        n=(8-(n%7));
        for(int i=0;i<n;i++)
                strcat(instruction," ");
        strcat(instruction,temp);
  }

}
//---------------------------------------------------------------------------
int testchar(char test)
{
  if(((test<0x3a)&&(test>0x2f))||((test<0x47)&&(test>0x40)))
        return 0;       //w}
  else if(test==0x40)  //@
        return 1;       //w}
  else if(test==0x52)
        return 2;       //Ȧsw}
  else if(test==0x23)
        return 3;       //ߧYw}
}
//---------------------------------------------------------------------------
void findr(char temp[64], char data[10])
{
  int l=strlen(data);
  int p;

  p=data[l-1]-0x30;
  temp[0]=0x31;
  temp[1]=(p/4)+0x30;
  temp[2]=((p%4)/2)+0x30;
  temp[3]=((p%4)%2)+0x30;
  temp[4]='\0';
}
//---------------------------------------------------------------------------
void finda(char temp[64], char data)
{
  int g;
  if(data<0x3a)
        g=data-0x30;
  else if((data>0x40)&&(data<0x47))
        g=(data-0x41)+10;

  if(data<0x47)
  {
        temp[0]=(g/8)+0x30;
        temp[1]=((g%8)/4)+0x30;
        temp[2]=(((g%8)%4)/2)+0x30;
        temp[3]=(((g%8)%4)%2)+0x30;
        temp[4]='\0';
  }
  else
        temp[0]='\0';
}
//---------------------------------------------------------------------------
void  mov_Rn(char temp[64], char test)
{
  temp[4]='\0';
  temp[0]=0x31;
  temp[1]=((test-0x30)/4)+0x30;
  temp[2]=(((test-0x30)%4)/2)+0x30;
  temp[3]=(((test-0x30)%4)%2)+0x30;
}
//---------------------------------------------------------------------------
void mov_data(char temp[64], char data2[10])
{
  int t[8];

  if(data2[2]>0x2f&&data2[2]<0x3a)
  {
        t[4]=0;
        t[5]=(data2[2]-0x30)/4;
        t[6]=((data2[2]-0x30)%4)/2;
        t[7]=((data2[2]-0x30)%4)%2;
  }
  else
  {
        t[4]=1;
        t[5]=(data2[2]-0x41)/4;
        t[6]=((data2[2]-0x41)%4)/2;
        t[7]=((data2[2]-0x41)%4)%2;
  }
  if(data2[1]>0x2f&&data2[1]<0x3a)
  {
        t[0]=0;
        t[1]=(data2[1]-0x30)/4;
        t[2]=((data2[1]-0x30)%4)/2;
        t[3]=((data2[1]-0x30)%4)%2;
  }
  else
  {
        t[0]=1;
        t[1]=(data2[1]-0x41)/4;
        t[2]=((data2[1]-0x41)%4)/2;
        t[3]=((data2[1]-0x41)%4)%2;
  }

  for(int a=0;a<8;a++)
        temp[a]=(t[a]+0x30);

  temp[8]='\0';
}
//---------------------------------------------------------------------------
void mv_R(char temp[64], char test)
{
  int tem[4];

  tem[0]=0;
  tem[1]=(test-0x30)/4;
  tem[2]=((test-0x30)%4)/2;
  tem[3]=((test-0x30)%4)%2;

  for(int a=0;a<4;a++)
        temp[a]=tem[a]+0x30;

  temp[4]='\0';
}
//---------------------------------------------------------------------------
void pin(char temp[64],char test)
{
  int x=test-0x30;

  if(x==0)
        strcpy(temp,"10000000");
  else if(x==1)
        strcpy(temp,"10010000");
  else if(x==2)
        strcpy(temp,"10100000");
  else
        strcpy(temp,"10110000");

  temp[8]='\0';
}
//---------------------------------------------------------------------------
void showlst(char table[20], char oper[6], char data1[10], char data2[10], char data3[10], char code[64], int n, char loc[5])
{
  char space[300];
  int toper=0, le;

  for(int a=0;a<5;a++)
        toper+=oper[a];

  linecount(space, n);

  //for+1=spaceҩlm
  space[9]=0x0;                //ҩlm
  strcat(space,loc);
  go_8(space);
  strcat(space,"  ");
  if(strlen(table)==0)
  {
          for(int i=0;i<8;i++)
                strcat(space," ");
  }
  else
  {
        strcat(space,table);
        if(strlen(table)<=4)
                go_8(space);
        strcat(space," ");
        if(strlen(table)<7)
                strcat(space," ");
  }

  strcat(space,oper);
  go_8(space);

  switch(toper)
  {
        case 201:       //ADD
        {
                strcat(space,data1);
                strcat(space,",");
                strcat(space,data2);
                break;
        }
        case 242:       //MOV
        {
                strcat(space,data1);
                strcat(space,",");
                strcat(space,data2);
                break;
        }
        case 158:       //RL
        {
                strcat(space,data1);
                break;
        }
        case 164:       //RR
        {
                strcat(space,data1);
                break;
        }
        case 284:       //CALL
        {
                strcat(space,data1);
                break;
        }
        case 231:       //JMP
        {
                strcat(space,data1);
                break;
        }
        case 310:       //DJNZ
        {
                strcat(space,data1);
                strcat(space,",");
                strcat(space,data2);
                break;
        }
        case 232:       //ORG
        {
                strcat(space,loc);
                strcat(space,"H");
                break;
        }
        default:
                break;
  }

  le=54-strlen(space);
  for(int j=0;j<le;j++)
        strcat(space," ");

  if((strcmp(oper,"END")!=0)&&(strcmp(oper,"ORG")!=0))
        strcat(space,code);
  le=strlen(space);
  space[le]='\0';

  Form1->StringGrid2->RowCount+=1;
  Form1->StringGrid2->Cells[0][n]=AnsiString(space);
}
//---------------------------------------------------------------------------
void modhex(char data[10])
{
  int temp[4];
  int p=0;

  if(((data[strlen(data)]=='b')||(data[strlen(data)]=='B')))
  {
        for(int i=0;i<strlen(data);i++)
        {
                if(((data[i]<0x3a)&&(data[i]>0x2f)))
                {
                        temp[i%4]=(data[i]-0x30);
                        if(i%4==0)
                        {
                                data[p]=(temp[0]*8+temp[1]*4+temp[2]*2+temp[3]);
                                if(data[p]>9)
                                {
                                        data[p]=data[p]%10;
                                        data[p]+=0x41;
                                }
                                else
                                        data[p]+=0x30;
                                p++;
                        }
                }
        }
  }
  data[p]='\0';
}
//---------------------------------------------------------------------------
void modobj(char objmod[17])
{
  int lon=strlen(objmod), temp[5], lon2;
  char modifed[10];
  lon2=lon/4;

  for(int p=0;p<lon2;p++)
  {
        temp[0]=objmod[0+4*p]-0x30;
        temp[1]=objmod[1+4*p]-0x30;
        temp[2]=objmod[2+4*p]-0x30;
        temp[3]=objmod[3+4*p]-0x30;
        temp[4]=8*temp[0]+4*temp[1]+2*temp[2]+temp[3];
        if(temp[4]<10)
                modifed[p]=temp[4]+0x30;
        else
                modifed[p]=(temp[4]-10)+0x41;
  }
  modifed[lon2]='\0';
  strcpy(objmod,modifed);
  objmod[lon2]='\0';

}
//---------------------------------------------------------------------------
void showobj(char code[64], char loc[5])
{
  char obj[8], chtem[3];
  int len=strlen(code), temp[5];

  len=len/4;
  if(len<10)
  {
        chtem[0]=0x30;
        chtem[1]=len+0x30;;
  }
  else
  {
        chtem[0]=0x31;
        chtem[1]=(len-10)+0x30;
  }
  chtem[2]='\0';
  loc[4]='\0';
  strcpy(obj,"T^");
  strcat(obj,loc);
  strcat(obj,"^");
  strcat(obj,chtem);
  strcat(obj,"^");

  for(int p=0;p<len;p++)
  {
        temp[0]=code[0+4*p]-0x30;
        temp[1]=code[1+4*p]-0x30;
        temp[2]=code[2+4*p]-0x30;
        temp[3]=code[3+4*p]-0x30;
        temp[4]=8*temp[0]+4*temp[1]+2*temp[2]+temp[3];

        if(temp[4]<10)
                obj[10+p]=temp[4]+0x30;
        else
                obj[10+p]=(temp[4]-10)+0x41;
  }
  obj[10+len]='\0';

  Form1->StringGrid3->RowCount++;
  Form1->StringGrid3->Cells[0][(Form1->StringGrid3->RowCount-1)]=AnsiString(obj);
}
//---------------------------------------------------------------------------
void fix_8(char eig_bits[9], char self_loc[5], char othe_loc[5])
{
  unsigned int num[4], sel_temp[5], oth_temp[5], final;

  for(int t=0;t<4;t++)
  {
        if((self_loc[t]<0x3a)&&(self_loc[t]>0x2f))
                sel_temp[t]=(self_loc[t]-0x30);
        else
                sel_temp[t]=(self_loc[t]-0x41)+10;

        if((othe_loc[t]<0x3a)&&(othe_loc[t]>0x2f))
                oth_temp[t]=(othe_loc[t]-0x30);
        else
                oth_temp[t]=(othe_loc[t]-0x41)+10;

  }

  sel_temp[4]=16*16*16*sel_temp[0]+16*16*sel_temp[1]+16*sel_temp[2]+sel_temp[3];
  oth_temp[4]=16*16*16*oth_temp[0]+16*16*oth_temp[1]+16*oth_temp[2]+oth_temp[3];

  final=oth_temp[4]-sel_temp[4];

  sel_temp[0]=final/16;
  sel_temp[1]=final%16;

  for(int q=0;q<2;q++)
  {
        eig_bits[0+4*q]=(sel_temp[q]/8)+0x30;
        eig_bits[1+4*q]=((sel_temp[q]%8)/4)+0x30;
        eig_bits[2+4*q]=(((sel_temp[q]%8)%4)/2)+0x30;
        eig_bits[3+4*q]=(((sel_temp[q]%8)%4)%2)+0x30;
  }
  if(eig_bits[0]==0x2f)
        eig_bits[0]=0x31;
  eig_bits[8]='\0';
}
//---------------------------------------------------------------------------
void fix_16(char six_bits[17], char othe_loc[5])
{
  int num[4], temp[4];
  for(int t=0;t<4;t++)
  {
        if((othe_loc[t]<0x3a)&&(othe_loc[t]>0x2f))
                temp[t]=(othe_loc[t]-0x30);
        else
                temp[t]=(othe_loc[t]-0x41)+10;

        for(int p=0;p<4;p++)
                num[p]=0;

        num[0]=temp[t]/8;
        num[1]=(temp[t]%8)/4;
        num[2]=((temp[t]%8)%4)/2;
        num[3]=((temp[t]%8)%4)%2;

        for(int q=0;q<4;q++)
        {
                six_bits[q+(4*t)]=0x30+num[q];
        }
  }
  six_bits[16]='\0';
}
//---------------------------------------------------------------------------
void pass2(char instruction[200])
{
  int l, g;
  char tab1[15], becom[15], self_loc[5], othe_loc[5], eig_bits[9], six_bits[17];
  char objmod[17], last_obj[100];

  for(int k=0;k<(Form1->StringGrid4->RowCount);k++)
  {
        strcpy(instruction,(Form1->StringGrid2->Cells[0][StrToInt((Form1->StringGrid4->Cells[2][k]).c_str())]).c_str());
        strcpy(last_obj,(Form1->StringGrid3->Cells[0][StrToInt((Form1->StringGrid4->Cells[2][k]).c_str())-1]).c_str());
        l=strlen(instruction);

        if((Form1->StringGrid4->Cells[1][k])=="$")
        {
                instruction[(l-2)]='\0';
                strcat(instruction,"00000000");
                strcpy(objmod,"00000000");
        }
        else
        {
                strcpy(tab1,(Form1->StringGrid5->Cells[0][0]).c_str());
                l=strlen(tab1);
                for(int w=l;w<15;w++)
                        tab1[w]='\0';
                strcpy(becom,(Form1->StringGrid4->Cells[1][k]).c_str());
                l=strlen(becom);
                for(int w=l;w<15;w++)
                        becom[w]='\0';

                g=0;
                while(1)
                {
                        if(strcmp(becom,tab1)==0)
                                break;
                        if(g==(Form1->StringGrid5->RowCount))
                                exit(0);
                        g++;
                        strcpy(tab1,((Form1->StringGrid5->Cells[0][g]).c_str()));
                        l=strlen(tab1);
                        for(int w=l;w<15;w++)
                                tab1[w]='\0';
                }

                strcpy(self_loc,(Form1->StringGrid4->Cells[0][k]).c_str());
                self_loc[4]='\0';
                strcpy(othe_loc,(Form1->StringGrid5->Cells[1][g]).c_str());
                othe_loc[4]='\0';

                l=strlen(instruction);
                if(instruction[(l-2)]==0x69)
                {
                        fix_8(eig_bits, self_loc, othe_loc);
                        instruction[(l-2)]='\0';
                        strcat(instruction,eig_bits);
                        strcpy(objmod,eig_bits);
                        objmod[8]='\0';
                }
                else
                {
                        fix_16(six_bits, othe_loc);
                        instruction[(l-2)]='\0';
                        strcat(instruction,six_bits);
                        strcpy(objmod,six_bits);
                        objmod[16]='\0';
                }
        }
        modobj(objmod);

        int shift=strlen(objmod), last_shift=shift+(last_obj[8]-0x30);
        if(last_shift<10)
                last_obj[8]=last_shift+0x30;
        else
                last_obj[8]=(last_shift-10)+0x41;

        strcat(last_obj,objmod);
        Form1->StringGrid3->Cells[0][StrToInt((Form1->StringGrid4->Cells[2][k]).c_str())-1]=AnsiString(last_obj);
        Form1->StringGrid2->Cells[0][StrToInt((Form1->StringGrid4->Cells[2][k]).c_str())]=AnsiString(instruction);
  }
}
//---------------------------------------------------------------------------
void progcou(char location[5])
{
  location[3]+=ins;

  for(int a=0;a<4;a++)
  {
        for(int b=0;b<4;b++)
        {
                if((location[b]>0x39)&&(location[b]<0x41))
                        location[b]=((location[b]-0x30)-10)+0x41;
                else if(location[b]>0x46)
                {
                        location[b-1]+=1;
                        location[b]=((location[b]-0x46)+0x2f);
                }
        }
  }
}
//---------------------------------------------------------------------------
void trueoper(char location[5], char table[20], char oper[6], char data1[10], char data2[10], char data3[10], char code[64], int n)
{
  int r, r2;
  char temp[64];
  int toper=0;

  for(int a=0;a<5;a++)
        toper+=oper[a];

  switch(toper)
  {
        case 201:       //ADD
        {
                strcpy(code,"0010");
                r=testchar(data2[0]);

                if(r==0)        //w}
                {
                        strcat(code,"0101");
                        modhex(data2);
                        strcat(code,data2);
                        ins=2;
                }
                else if(r==1)   //w}
                {
                        if(data2[2]==0x30)
                                strcat(code,"0110");
                        else if(data2[2]==0x31)
                                strcat(code,"0111");
                        ins=1;
                }
                else if(r==2)   //Ȧsw}
                {
                        findr(temp,data2);
                        strcat(code,temp);
                        ins=1;
                }
                else            //ߧYw}
                {
                        strcat(code,"0100");
                        finda(temp,data2[1]);
                        strcat(code,temp);
                        finda(temp,data2[2]);
                        strcat(code,temp);
                        ins=2;
                }

                r=strlen(code);
                code[r]='\0';
                break;
        }
        case 242:       //MOV
        {
                if((data1[0]==0x41)||(data1[0]==0x42))    //A or B
                {
                        if(data2[0]==0x52)       //Rn
                        {
                                strcpy(code,"1110");
                                mov_Rn(temp,data2[1]);
                                strcat(code,temp);
                                code[strlen(code)]='\0';
                                ins=1;
                                break;
                        }
                        else if(data2[0]==0x40)  //@
                        {
                                strcpy(code,"1110");
                                if(data2[2]==0x30)
                                        strcat(code,"0110");
                                else if(data2[2]==0x31)
                                        strcat(code,"0111");
                                code[strlen(code)]='\0';
                                ins=1;
                                break;
                        }
                        else if(data2[0]==0x23)  //#
                        {
                                strcpy(code,"1110");
                                strcat(code,"0100");
                                mov_data(temp,data2);
                                strcat(code,temp);
                                ins=2;
                                break;
                        }
                }
                else if((data1[0]==0x52))        //Rn
                {
                        mv_R(temp,data1[1]);

                        if(data2[0]==0x41)      //A
                        {
                                strcpy(code,"1111");
                                strcat(code,temp);
                                ins=1;
                                break;
                        }
                        else if(data2[0]==0x23)       //#
                        {
                                strcpy(code,"0111");
                                strcat(code,temp);
                                if((data2[3]>0x40)&&(data2[3]<0x47))
                                {
                                        finda(temp,data2[2]);
                                        strcat(code,temp);
                                        finda(temp,data2[3]);
                                        strcat(code,temp);
                                }
                                else
                                {
                                        finda(temp,data2[1]);
                                        strcat(code,temp);
                                        finda(temp,data2[2]);
                                        strcat(code,temp);
                                }
                                ins=2;
                                break;
                        }
                }
                else if((data1[0]==0x50))        //direct of Px  (by FSR table)
                {
                        pin(temp,data1[1]);
                        strcpy(code,temp);
                        finda(temp,data2[1]);
                        strcat(code,temp);
                        finda(temp,data2[2]);
                        strcat(code,temp);
                        ins=2;
                        break;
                }
        }
        case 158:       //RL
        {
                ins=1;
                strcpy(code,"00100011");
                break;
        }
        case 164:       //RR
        {
                ins=1;
                strcpy(code,"00010011");
                break;
        }
        case 284:       //CALL
        {
                strcpy(code,"00010010");
                strcat(code,"z?");              //bytewX

                if(s_d!=0)
                        Form1->StringGrid4->RowCount+=1;
                Form1->StringGrid4->Cells[0][s_d]=AnsiString(location);
                Form1->StringGrid4->Cells[1][s_d]=AnsiString(data3);
                Form1->StringGrid4->Cells[2][s_d]=AnsiString(IntToStr(n));
                s_d++;
                ins=3;
                break;
        }
        case 231:       //JMP
        {
                strcpy(code,"00000010");
                strcat(code,"z?");               //bytewX

                if(s_d!=0)
                        Form1->StringGrid4->RowCount+=1;
                Form1->StringGrid4->Cells[0][s_d]=AnsiString(location);
                Form1->StringGrid4->Cells[1][s_d]=AnsiString(data3);
                Form1->StringGrid4->Cells[2][s_d]=AnsiString(IntToStr(n));
                s_d++;
                ins=3;
                break;
        }
        case 310:       //DJNZ
        {
                strcpy(code,"1101");
                mv_R(temp,data1[1]);
                strcat(code,temp);
                strcat(code,"i?");        //@bytewX

                if(s_d!=0)
                        Form1->StringGrid4->RowCount+=1;
                Form1->StringGrid4->Cells[0][s_d]=AnsiString(location);
                Form1->StringGrid4->Cells[1][s_d]=AnsiString(data3);
                Form1->StringGrid4->Cells[2][s_d]=AnsiString(IntToStr(n));
                s_d++;
                ins=2;
                break;
        }
        case 235:       //RET
        {
                strcpy(code,"00100010");
                ins=1;
                break;
        }
        default:
                break;
  }
}
//---------------------------------------------------------------------------
void fakeoper(int state, char oper[6], char data1[10], char location[5])
{
//  ShowMessage(state);

  if(state==3)  //ORG
  {
        data1[4]='\0';
        strcpy(location,data1);
//        ShowMessage(data1);
//        ShowMessage(location);
  }
  else  //DORGUнX
  {
        int fakeins=0;

        for(int a=0;a<5;a++)
                fakeins+=data1[a];
//        ShowMessage(fakeins);

        switch(fakeins)
        {
          case 215:     //END
          {
                break;
          }
          case 235:     //EQU
          {
                break;
          }
          case 134:     //DB
          {
                break;
          }
          case 155:     //DW
          {
                break;
          }
          case 304:     //LONG
          {
                break;
          }
          case 222:     //REG
          {
                break;
          }
          case 308:     //RETI
          {
                break;
          }
          case 233:     //VAR
          {
                break;
          }
          default:
                break;
        }
  }
}
//---------------------------------------------------------------------------
void writetable(char table[20], char location[5], int t_d)
{
  int l=strlen(table);

  table[l-1]='\0';

  if(t_d!=0)
        Form1->StringGrid5->RowCount+=1;
  Form1->StringGrid5->Cells[0][t_d+0]=AnsiString(table);
  Form1->StringGrid5->Cells[1][t_d+0]=AnsiString(location);
}
//---------------------------------------------------------------------------
void clas_data(char insleft[200], char data[10])
{
  char *p;
  int g=0;

  for(int c=0;c<10;c++)
        data[c]='\0';

  if((p=strstr(insleft,"\x0a"))!=NULL)
        *p=0x0;
  if((p=strstr(insleft,"\x0d"))!=NULL)
        *p=0x0;
  if((p=strstr(insleft,"0x3b"))!=NULL)
        *p=0x0;

  while(strlen(insleft)>g)
  {
        if((insleft[g]!=0x09)&&(insleft[g]!=0x2c)&&(insleft[g]!=0x20)&&(insleft[g]!=0x3b))
        {
                data[g]=insleft[g];
                g++;
        }
        else
        {
                for(int a=g+1;a<((strlen(insleft)+strlen(data)));a++)
                        insleft[a-(g+1)]=insleft[a];
                break;
        }
  }

//  ShowMessage(data);
//  ShowMessage(insleft);
}
//---------------------------------------------------------------------------
int clas_oper(char insleft[200], char oper[6], bool fake, bool orgf)
{
  int state;
  char *p;
  int g=0;
  char org1[4], org2[4];

  strcpy(org1,"ORG\0");

  for(int c=0;c<6;c++)
        oper[c]='\0';

  if((p=strstr(insleft,"\x0a"))!=NULL)
        *p=0x0;
  if((p=strstr(insleft,"\x0d"))!=NULL)
        *p=0x0;
  if((p=strstr(insleft,"0x3b"))!=NULL)
        *p=0x0;

  if((p=strstr(insleft,"\x09"))==NULL)
        fake=1;

  while((p=strstr(insleft,"\x09"))!=NULL)
  {
        if(insleft[g]!=0x09)
        {
                oper[g]=insleft[g];
                g++;
        }
        else
        {
                for(int a=g+1;a<((strlen(insleft)+strlen(oper)));a++)
                        insleft[a-(g+1)]=insleft[a];
                break;
        }
  }

  int lence;

  lence=strlen(oper);
  for(int i=0;i<lence;i++)
        oper[i]=toupper(oper[i]);

  if((strcmp(org1,oper)==0))
  {

        fake=1;
        orgf=1;
  }

  if((fake==0)&&(orgf==0))
        return state=0;
  else if((fake==1)&&(orgf==0))
  {
        strcpy(oper,insleft);
        return state=1;
  }
  else if((fake==1)&&(orgf==1))
        return state=3;
}
//---------------------------------------------------------------------------
void clas_table(char instruction[200], char table[20], char insleft[200])
{
  char *p;
  int g=0;

  for(int c=0;c<20;c++)
        table[c]='\0';

  if((p=strstr(instruction,"\x0a"))!=NULL)
        *p=0x0;
  if((p=strstr(instruction,"\x0d"))!=NULL)
        *p=0x0;
  if((p=strstr(instruction,"0x3b"))!=NULL)
        *p=0x0;

  while((p=strstr(instruction,"\x09"))!=NULL)
  {
        if(instruction[g]!=0x09)
        {
                table[g]=instruction[g];
                g++;
        }
        else
        {
                for(int a=1;a<(strlen(instruction));a++)
                        insleft[a-1]=instruction[a];
                break;
        }
  }

  int i=0;
  for(int a=(strlen(table)+1);a<200;a++)
  {
        insleft[i]=instruction[a];
        i++;
  }

//  ShowMessage(table);
}
//---------------------------------------------------------------------------
void showasm(char instruction[200], int n)
{
  char space[200];

  linecount(space, n);

  space[9]=0x0;                //ҩlm
  strcat(space,instruction);

  Form1->StringGrid1->RowCount+=1;
  Form1->StringGrid1->Cells[0][n]=AnsiString(space);
//  ShowMessage(instruction);
}
//---------------------------------------------------------------------------
void scan(char instruction[200])
{
  fgets(instruction,99,dfpa);   //r
}
//---------------------------------------------------------------------------
void preprint()
{
  char obj[100];
//  fwrite("H^",2,1,dfpo);
  strcpy(obj,"H^");
  strcat(obj,(Form1->Edit1->Text).c_str());
  fprintf(dfpo,"%s\n",obj);
  fprintf(dfpl,"  Line   Loc      Source statment                     Object code\n",obj);
  fprintf(dfpl,"==============================================================================\n",obj);


  Form1->StringGrid1->Cells[0][0]=AnsiString("Line     Source File");
  Form1->StringGrid2->Cells[0][0]=AnsiString("Line     Loc      Source Statement                    Object code");
  Form1->StringGrid3->Cells[0][0]=AnsiString(obj);
}
//---------------------------------------------------------------------------
void subject()
{
  int n=1;
  int state, leance;
  bool orgf, fake;
  char instruction[200], insleft[200];
  char location[5], table[20], oper[6], data1[10], data2[10], data3[10];
  char code[64], old_loc[5];
  int t_d=0;

  code[0]='\0';

  strcpy(location,"0000H");

  preprint();   //CLYT

  while(!feof(dfpa))
  {
        fake=0;
        orgf=0;

        scan(instruction);       //ŪJasmɮסAs
        clas_table(instruction, table, insleft);//Xtabler
        state=clas_oper(insleft, oper, fake, orgf);         //Xoperr
        clas_data(insleft, data1);             //ܼƤ@
        clas_data(insleft, data2);             //ܼƤG
        clas_data(insleft, data3);             //ܼƤT

        int fa=0;
        for(int a=0;a<5;a++)
                fa+=data1[a];

        if(((state==1)||(state==3))&&(fa!=235))
        {
                fakeoper(state, oper, data1, location);
                strcpy(code,"");
                ins=0;
        }
        else
        {
                trueoper(location, table, oper, data1, data2, data3, code, n);
                progcou(location);
        }

        if(strlen(table)!=0)    //Otable}
        {
        if((Form1->StringGrid2->RowCount)==1)
                writetable(table, location, t_d);
        else
                writetable(table, old_loc, t_d);

        t_d++;
        }

  /************  JOnN᭱dataӼƷru *****************/

        modins(instruction);          //ץtabAHspaceN8

        showasm(instruction, n);      //Nasmܩ

        if((Form1->StringGrid2->RowCount)==1)           //Nlstܩ
                showlst(table, oper, data1, data2, data3, code, n, location);      //Nlstܦb
        else
                showlst(table, oper, data1, data2, data3, code, n, old_loc);      //Nlstܦb

        leance=strlen(code);
        if(leance!=0)
                showobj(code, old_loc);

        strcpy(old_loc,location);
        n+=1;
        Form1->CGauge1->Progress=n;
  }
  ch_count=n;           //o`

  Form1->StringGrid3->RowCount++;
  Form1->StringGrid3->Cells[0][(Form1->StringGrid3->RowCount)-1]=AnsiString("E^END_of_the_File");

  //gXPass 1 Gsymtab.
  char path[100], *p;
  strcpy(path,((Form1->Edit2->Text).c_str()));
  
  p=strrchr(path,0x5c);         // p = \xxxx.obj
  path[(strlen(path)-strlen(p)+1)]='\0';

  strcat(path,"pas1_stb.txt");
  dfpx=fopen(path,"w");

  for(int k=0;k<(Form1->StringGrid2->RowCount);k++)
        fprintf(dfpx,"%s\n",(Form1->StringGrid2->Cells[0][k]));
  Form1->CGauge1->Progress++;

  for(int m=0;m<3;m++)
        fprintf(dfpx,"\n",Form1->StringGrid2->Cells[0][m]);
  Form1->CGauge1->Progress++;

  for(int k=0;k<(Form1->StringGrid5->RowCount);k++)
        fprintf(dfpx,"%8s %s\n",(Form1->StringGrid5->Cells[0][k]),(Form1->StringGrid5->Cells[1][k]));
  Form1->CGauge1->Progress++;

  for(int m=0;m<3;m++)
        fprintf(dfpx,"\n",Form1->StringGrid2->Cells[0][m]);
  Form1->CGauge1->Progress++;

  for(int k=0;k<(Form1->StringGrid4->RowCount);k++)
        fprintf(dfpx,"%8s %7s %s\n",(Form1->StringGrid4->Cells[0][k]),(Form1->StringGrid4->Cells[1][k]),(Form1->StringGrid4->Cells[2][k]));
  Form1->CGauge1->Progress++;
  fclose(dfpx);


  //iPass2
  pass2(instruction);
  Form1->CGauge1->Progress++;

  //Xlst
  for(int k=1;k<(Form1->StringGrid2->RowCount);k++)
        fprintf(dfpl,"%s\n",(Form1->StringGrid2->Cells[0][k]));
  Form1->CGauge1->Progress++;

  //Xobj
  for(int k=1;k<(Form1->StringGrid3->RowCount);k++)
        fprintf(dfpo,"%s\n",(Form1->StringGrid3->Cells[0][k]));
  Form1->CGauge1->Progress++;

  Form1->CGauge1->Progress=100;
  closefile();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  SaveDialog1->Execute();
  Edit3->Text=SaveDialog1->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  SaveDialog2->Execute();
  Edit2->Text=SaveDialog2->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  OpenDialog1->Execute();
  Edit1->Text=OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  CGauge1->Progress=0;

  Button1->Enabled=1;
  Button2->Enabled=1;
  Button3->Enabled=1;
  Button5->Enabled=1;

  Edit1->Text="C:\\Work\\sample.asm";
  Edit2->Text="C:\\Work\\sample.obj";
  Edit3->Text="C:\\Work\\sample.lst";

  StringGrid1->RowCount=1;
  StringGrid2->RowCount=1;
  StringGrid3->RowCount=1;
  StringGrid5->RowCount=1;
  StringGrid1->Cells[0][0]=AnsiString("");
  StringGrid2->Cells[0][0]=AnsiString("");
  StringGrid3->Cells[0][0]=AnsiString("");
  StringGrid5->Cells[0][0]=AnsiString("");
  StringGrid5->Cells[1][0]=AnsiString("");
  closefile();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  if(Edit1->Text=="")
        Edit1->Text="C:\\Work\\sample.asm";
  if(Edit2->Text=="")
        Edit2->Text="C:\\Work\\sample.obj";
  if(Edit3->Text=="")
        Edit3->Text="C:\\Work\\sample.lst";
  else
  {
        Button1->Enabled=0;
        Button2->Enabled=0;
        Button3->Enabled=0;
        Button5->Enabled=0;
        dfpa=fopen((Edit1->Text).c_str(),"rb");
        dfpo=fopen((Edit2->Text).c_str(),"wb");
        dfpl=fopen((Edit3->Text).c_str(),"wb");

        subject();
  }
}
//---------------------------------------------------------------------------




